Option Explicit
'Version du 9 juillet 2014
'Ouvrir un fichier texte en mode stream, charge son contenu en mmoire, le modifie puis rcrit le rsultat

Dim objFSO, objFolder, MyFile, PathToFile, PathToFileCible, PathToParameters, objMyTextFile, objMyTextStream, FileContent, CheminScriptActuel
Dim MyFileTextArray, intUpper, CompteurLigne, ChaineRecherchee, ChaineDeRemplacement

'Dclaration des constantes
Const ForReading = 1
Const ForWritting = 2
Const ForAppending = 8

const TristateFalse = 0

CheminScriptActuel = Left(wscript.scriptfullname,Len(wscript.scriptfullname)-Len(wscript.scriptname)-1) 'Contient le chemin du rpertoire du script

PathToParameters = CheminScriptActuel & "\" & "_Parameters.txt"
'PathToFile = "C:\MonFichierALire.txt"
'PathToFileCible = "C:\MonFichierAEcrire.txt"

Set objFSO = CreateObject("Scripting.FileSystemObject")

'Chargement du fichier avec les paramtres
set objMyTextFile = objFSO.GetFile(objFSO.GetAbsolutePathName(PathToParameters))
set objMyTextStream = objMyTextFile.OpenAsTextStream(ForReading, TristateFalse)

FileContent = objMyTextStream.Read(objMyTextFile.Size)

MyFileTextArray = Split(FileContent, vbCrLf)

intUpper = Ubound(MyFileTextArray)
If Err.Number = 0 Then 'If the array is not empty
	If Ubound(MyFileTextArray) < 4 Then
		Wscript.echo "Il manque des paramtres dans le fichier de configuration"
		Wscript.Quit
	End If
End If

objMyTextStream.Close
Set objMyTextStream = Nothing
Set objMyTextFile = Nothing


'Effacement des fichiers contenus dans le rpertoire cible
objFSO.DeleteFile CheminScriptActuel & "\" & "Unattend_Files_Configured\*.*", True

'Set oDossier = objFSO.GetFolder (Dossier)
'For Each Sous_Dos in oDossier.SubFolders
	'objFSO.DeleteFolder Sous_Dos, True
'Next


'Passage en revue des fichiers source
Set objFolder = objFSO.GetFolder(CheminScriptActuel & "\" & "Template")
For Each MyFile In objFolder.Files
	'Wscript.echo MyFile.Name

	PathToFile = MyFile.Path
	PathToFileCible = CheminScriptActuel & "\" & "Unattend_Files_Configured\" & MyFile.Name


	'Ouverture et lecture du contenu du fichier
	set objMyTextFile = objFSO.GetFile(objFSO.GetAbsolutePathName(PathToFile))
	set objMyTextStream = objMyTextFile.OpenAsTextStream(ForReading, TristateFalse)

	FileContent = objMyTextStream.Read(objMyTextFile.Size)

	objMyTextStream.Close
	Set objMyTextStream = Nothing
	Set objMyTextFile = Nothing

	'Cration/Effacement du fichier cible. Dans le cas d'un fichier cible diffrent du fichier source, il faut le crer au pralable avant de l'ouvrir en criture
	Set objMyTextFile = objFSO.CreateTextFile(PathToFileCible, True)
	objMyTextFile.Close
	Set objMyTextFile = Nothing

	'Modification et criture du nouveau contenu dans le fichier
	set objMyTextFile = objFSO.GetFile(objFSO.GetAbsolutePathName(PathToFileCible))
	set objMyTextStream = objMyTextFile.OpenAsTextStream(ForWritting, TristateFalse)

	'Remplacement d'lments avec ceux prsents dans le fichier de configuration
	For CompteurLigne = LBound(MyFileTextArray) To Ubound(MyFileTextArray)
		'MyFileTextArray(CompteurLigne)
		ChaineDeRemplacement = MyFileTextArray(CompteurLigne)
		
		Select Case CompteurLigne
			Case 0 'NomMachine
				ChaineRecherchee = "##MachineName##"
			
			Case 1 'Login local
				ChaineRecherchee = "##LocalLoginName##"

			Case 2 'Mot de passe local
				ChaineRecherchee = "##LocalPassword##"

			Case 3 'Nom du domaine
				ChaineRecherchee = "##DomainName##"

			Case 4 'Login de domaine
				ChaineRecherchee = "##DomainLoginName##"

			Case 5 'Mot de passe de domaine
				ChaineRecherchee = "##DomainPassword##"

			Case 6 'Ip machine
				ChaineRecherchee = "##MachineIP##"

			Case 7 'Subnet Mask
				ChaineRecherchee = "##SubnetMask##"

			Case 8 'Gateway
				ChaineRecherchee = "##Gateway##"

			Case 9 'DNS : first
				ChaineRecherchee = "##DNSServer1##"

			Case 10 'DNS : second
				ChaineRecherchee = "##DNSServer2##"

			Case 11 'Wins : first
				ChaineRecherchee = "##WinsServer1##"

			Case 12 'Wins : second
				ChaineRecherchee = "##WinsServer2##"

			Case 13 'DNS : suffixe
				ChaineRecherchee = "##DNSSuffix##"

			Case 14 'Sysprep post script
				ChaineRecherchee = "##SysprepPostScript##"
				ChaineDeRemplacement = CheminScriptActuel & "\" & "Unattend_Files_Configured\" & ChaineDeRemplacement
																
			Case Else
				ChaineDeRemplacement = "UnknowValue"
		
		End Select

		FileContent = Replace(FileContent,ChaineRecherchee,ChaineDeRemplacement)

	Next	
	
	objMyTextStream.Write(FileContent)
	objMyTextStream.Close
	Set objMyTextStream = Nothing
	Set objMyTextFile = Nothing

Next

Set objFolder = Nothing




Set objFSO = Nothing

Wscript.echo "Finish"
